// RSZVB Measurement ExampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RSZVB Measurement Example.h"
#include "RSZVB Measurement ExampleDlg.h"
#include "resource.h"
#include "rszvb.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRSZVBMeasurementExampleDlg dialog

CRSZVBMeasurementExampleDlg::CRSZVBMeasurementExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRSZVBMeasurementExampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRSZVBMeasurementExampleDlg)
	m_FileExport = _T("c:\\trace.csv");
	m_Query = TRUE;
	m_Reset = TRUE;
	m_ResName = _T("GPIB0::20::0::INSTR");
	m_Sin = 0;
	m_Sout = 1;
	m_SweepType = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRSZVBMeasurementExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRSZVBMeasurementExampleDlg)
	DDX_Control(pDX, IDC_CW_FREQUENCY, m_CWFrequency);
	DDX_Control(pDX, IDC_STOP_POWER, m_StopPower);
	DDX_Control(pDX, IDC_STOP_FREQUENCY, m_StopFrequency);
	DDX_Control(pDX, IDC_START_POWER, m_StartPower);
	DDX_Control(pDX, IDC_START_FREQUENCY, m_StartFrequency);
	DDX_Control(pDX, IDC_SOURCE_POWER, m_SourcePower);
	DDX_Control(pDX, IDC_FILE_BUTTON, m_FileButton);
	DDX_Control(pDX, IDC_GENERATE, m_Generate);
	DDX_Text(pDX, IDC_FILE_EXPORT, m_FileExport);
	DDX_Check(pDX, IDC_IDQUERY, m_Query);
	DDX_Check(pDX, IDC_RESET, m_Reset);
	DDX_Text(pDX, IDC_RESOURCE_NAME, m_ResName);
	DDX_CBIndex(pDX, IDC_SIN, m_Sin);
	DDX_CBIndex(pDX, IDC_SOUT, m_Sout);
	DDX_CBIndex(pDX, IDC_SWEEP_TYPE, m_SweepType);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRSZVBMeasurementExampleDlg, CDialog)
	//{{AFX_MSG_MAP(CRSZVBMeasurementExampleDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_FILE_BUTTON, OnFileButton)
	ON_BN_CLICKED(IDC_GENERATE, OnGenerate)
	ON_CBN_SELCHANGE(IDC_SWEEP_TYPE, OnSelchangeSweepType)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRSZVBMeasurementExampleDlg message handlers

BOOL CRSZVBMeasurementExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_SweepType = 0;
	m_SourcePower.EnableWindow(m_SweepType == 0);
	m_StopFrequency.EnableWindow(m_SweepType == 0);
	m_StartFrequency.EnableWindow(m_SweepType == 0);
	m_CWFrequency.EnableWindow(m_SweepType != 0);
	m_StopPower.EnableWindow(m_SweepType != 0);
	m_StartPower.EnableWindow(m_SweepType != 0);
	m_SourcePower.SetWindowText("0.0");
	m_StopFrequency.SetWindowText("4.0E+9");
	m_StartFrequency.SetWindowText("300.0E+3");
	m_CWFrequency.SetWindowText("1.000E+9");
	m_StopPower.SetWindowText("0.0");
	m_StartPower.SetWindowText("-25.0");
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRSZVBMeasurementExampleDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRSZVBMeasurementExampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRSZVBMeasurementExampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

/* Function handling when the File button is pressed */
void CRSZVBMeasurementExampleDlg::OnFileButton() 
{
	CString file;
	CFileDialog fileDlg( FALSE, NULL, NULL, OFN_ALLOWMULTISELECT | OFN_HIDEREADONLY, "All Files (*.*)|*.*||", this);

	if ( fileDlg.DoModal() == IDOK)
	{
		file = fileDlg.GetPathName();
	}
	m_FileExport = file;
	UpdateData(false);
}

/* Function handling when the Generate button is pressed */
void CRSZVBMeasurementExampleDlg::OnGenerate() 
{
    char		window_name[] = "MeasSetup";
    char		trace_name[] = "MeasTrace";
    ViInt32		channel = 1;
    ViInt32		window = 1;
    ViInt32		window_trace = 2;
    ViChar		catalog[1024];
	char		buffer[512],
				path[256],
				*p2buf;;
	ViStatus	rszvb_status;
	ViSession	instrSession;
		
	CString str;

	UpdateData();

	switch (m_Sin)
	{
		case 0: 
			m_Sin = 1;
			break;
		case 1: 
			m_Sin = 2;
			break;
		case 2: 
			m_Sin = 3;
			break;
		case 3: 
			m_Sin = 4;
			break;
		default: 
			m_Sin = 1;
	}
	switch (m_Sout)
	{
		case 0: 
			m_Sout = 1;
			break;
		case 1: 
			m_Sout = 2;
			break;
		case 2: 
			m_Sout = 3;
			break;
		case 3: 
			m_Sout = 4;
			break;
		default: 
			m_Sout = 1;
	}
	
	strcpy (path, m_FileExport);

	HCURSOR cur = LoadCursor ( NULL, IDC_WAIT );
		SetCursor ( cur );

    /* Initialize the driver */
	rszvb_status = rszvb_init((char *) ((LPCTSTR) m_ResName), (int)(m_Query), (int)(m_Reset), &instrSession);
	if (rszvb_status < 0)
	{
		AfxMessageBox ("Could not open the session!", MB_OK);
		cur = LoadCursor ( NULL, IDC_ARROW );
		SetCursor ( cur );
		return;
	}

    /* Initial setup - display on, create new window */
    FT_CHECKERR (rszvb_SetDisplayUpdate(instrSession, 1), "rszvb_SetDisplayUpdate");
    FT_CHECKERR (rszvb_WindowNew(instrSession, window_name), "rszvb_WindowNew");
    /* Delete all possibly opened traces */
    FT_CHECKERR (rszvb_TraceList(instrSession, channel, catalog, 1024), "rszvb_TraceList");
    
	p2buf = strtok(catalog, ",");

    while(p2buf)
    {
		FT_CHECKERR (rszvb_TraceDelete (instrSession, channel, p2buf), "rszvb_TraceDelete");
		/* Skip the meas parameter string, only trace name is important */
		p2buf = strtok(NULL, ",");
		if (p2buf)
			p2buf = strtok(NULL, ",");
    }

    /* Create a new trace */
    FT_CHECKERR (rszvb_TraceAdd(instrSession, channel, trace_name), "rszvb_TraceAdd");
    FT_CHECKERR (rszvb_TraceAssignDiagramArea(instrSession, window, window_trace, trace_name), "rszvb_TraceAssignDiagramArea");
    /* Set Sweep parameters */
    FT_CHECKERR (rszvb_SetSweepNumberOfPoints(instrSession, channel, 201), "rszvb_SetSweepNumberOfPoints");
    FT_CHECKERR (rszvb_SetSweepSingle(instrSession, channel, 0), "rszvb_SetSweepSingle");
    FT_CHECKERR (rszvb_SetSweepCount(instrSession, channel, 1), "rszvb_SetSweepCount");
    
	switch (m_SweepType)
	{
		case 0:
		{
			/* Frequency measurement validation */
			m_StartFrequency.GetWindowText(str);
			double start = atof(str);
			
			start = __min (start,8.0E9);
			start = __max (start,300.0E3);
			
			m_StopFrequency.GetWindowText(str);
			double stop = atof(str);

			stop = __min (stop,8.0E9);
			stop = __max (stop,300.0E3);

			m_SourcePower.GetWindowText(str);
			double power = atof(str);

			power = __min (power,10.0);
			power = __max (power,-40.0);
			
			FT_CHECKERR (rszvb_SetSweepType(instrSession, channel, 0), "rszvb_SetSweepType");
			FT_CHECKERR (rszvb_SetStartFrequency(instrSession, channel, start), "rszvb_SetStartFrequency");
			FT_CHECKERR (rszvb_SetStopFrequency(instrSession, channel, stop), "rszvb_SetStopFrequency");
			FT_CHECKERR (rszvb_SetPower(instrSession, channel, power), "rszvb_SetPower");
			break;
		}
        case 1:
		{
			/* Power measurement validation */
			m_CWFrequency.GetWindowText(str);
			double freq = atof(str);

			freq = __min (freq,8.0E9);
			freq = __max (freq,300.0E3);

			m_StartPower.GetWindowText(str);
			double start = atof(str);

			start = __min (start,10.0);
			start = __max (start,-40.0);
			
			m_StopPower.GetWindowText(str);
			double stop = atof(str);

			stop = __min (stop,10.0);
			stop = __max (stop,-40.0);
			
			FT_CHECKERR (rszvb_SetSweepType(instrSession, channel, 3), "rszvb_SetSweepType");
			FT_CHECKERR (rszvb_SetCWFrequency(instrSession, channel, freq), "rszvb_SetCWFrequency");
			FT_CHECKERR (rszvb_SetStopPower(instrSession, channel, stop), "rszvb_SetStopPower");
			FT_CHECKERR (rszvb_SetStartPower(instrSession, channel, start), "rszvb_SetStartPower");
			break;
		}
	}

	/* Selecting parameters */
    FT_CHECKERR (rszvb_SelectSParameters(instrSession, channel, trace_name, m_Sout, m_Sin), "rszvb_SelectSParameters");
    /* Measured data is presented in dB Mag */
	FT_CHECKERR (rszvb_SetTraceFormat(instrSession, channel, 0), "rszvb_SetTraceFormat");
    /* Starts a new single sweep sequence with timeout 30 s */
	FT_CHECKERR (rszvb_SendChannelTriggerWaitOPC(instrSession, channel, 30000), "rszvb_SendChannelTriggerWaitOPC");
    FT_CHECKERR (rszvb_TraceAutoscale(instrSession, window, window_trace), "rszvb_TraceAutoscale");
    /* Getting the directory*/
	FT_CHECKERR (rszvb_GetCurrentDirectory(instrSession, catalog), "rszvb_GetCurrentDirectory");
    
	p2buf = catalog + strlen(catalog);
    if (strrchr (path, '\\'))
    {
		sprintf (p2buf, "%s", strrchr (path, '\\'));
    }
    else
    {
        sprintf (p2buf, "\\%s", path);
    }
	
	/* Stores the trace data of a specified trace to a trace file */
    FT_CHECKERR (rszvb_TraceExportData(instrSession, trace_name, catalog), "rszvb_TraceExportData");
    /* Reads data from the instrument and writes them to a user specified file  */
	FT_CHECKERR (rszvb_readToFile(instrSession, catalog, path), "rszvb_readToFile");
	/* Deletes the indicated file */
    FT_CHECKERR (rszvb_FileManager(instrSession, 6, catalog, ""), "rszvb_FileManager");

    cur = LoadCursor ( NULL, IDC_ARROW );
	SetCursor ( cur );
		
}

/* Switching feature between frequency and power settings */
void CRSZVBMeasurementExampleDlg::OnSelchangeSweepType() 
{
	UpdateData();
	m_SourcePower.EnableWindow(m_SweepType == 0);
	m_StopFrequency.EnableWindow(m_SweepType == 0);
	m_StartFrequency.EnableWindow(m_SweepType == 0);
	m_CWFrequency.EnableWindow(m_SweepType != 0);
	m_StopPower.EnableWindow(m_SweepType != 0);
	m_StartPower.EnableWindow(m_SweepType != 0);
}

